/*  color.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "color.h"
#include <klocale.h>
#include <math.h>
#include <kdebug.h>

Color::Color(const QString &def, const QString &nam) : 
  Map(QString(),QStringList(), nam), m_color(def)
{
  m_isAClassName="Color";
  m_namedColor=def;
}

Color::Color(const int r, const int g, const int b) : Map(), m_color(r,g,b)
{
  m_isAClassName="Color";
}

Color::Color(const Color &c) : Map(c), m_color(c.m_color), m_namedColor(c.m_namedColor)
{
  m_isAClassName="Color";
}

Map *Color::copy(void) const
{
  return new Color(*this);
}

Map *Color::eval (const QDict <Map> &)
{
  return copy(); 
}

QString Color::string(void) const
{
  if (m_namedColor.isEmpty()) return m_color.name();
  return m_namedColor;
}

QString Color::help(void) const
{
  kdDebug() << helpPrefix() << endl;
  if (!m_name.isEmpty())
    return helpPrefix()+QString(i18n("<H3><I>%1 = %2</I></H3><P>User defined color<P>"))
//	"<H5><A HREF=\"math://RequestPlotFunction/%3\">Plot Function ...</A></H5>")
      .arg(m_name).arg(string())+helpPostfix();
  return helpPrefix()+QString(i18n("No help available"))+helpPostfix();
} 


