/*  color.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#ifndef _COLOR_H
#define _COLOR_H

#include "map.h"
#include <qcolor.h>
#include <qstring.h>

class Color : public Map
{
protected:
  
  QColor m_color;
  QString m_namedColor;

  public:
  Color(const QString &def, const QString &nam=QString());
  Color(const int r, const int g, const int b);
  Color(const Color &c);

  inline QColor color(void) { return m_color; };
  
  virtual Map *copy(void) const;

  virtual Map *eval (const QDict <Map> &vars);

  virtual QString string(void) const;
  virtual QString help(void) const;
  
};

#endif
