/*  init.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "trig.h"
#include "hyp.h"
#include "traspose.h"
#include "sqrt.h"
#include "factorial.h"
#include "datapolartorect.h"
#include "exp.h"
#include "../constant.h"

void init_functions(void)
{
  Map *cos = new Cos;
  cos->setName("Cos");
  Map *sin = new Sin;
  sin->setName("Sin");
  Map *tan= new Tan;
  tan->setName("Tan");
  Map *cosh = new Cosh;
  cosh->setName("Cosh");
  Map *sinh = new Sinh;
  sinh->setName("Sinh");
  Map *tanh= new Tanh;
  tanh->setName("Tanh");
  Map *traspose = new MatrixTraspose;
  traspose->setName("MatrixTraspose");
  Map *sqrt = new Sqrt;
  sqrt->setName("Sqrt");
  Map *factorial = new Factorial;
  factorial->setName("Factorial");
  Map *datapolartorect = new DataPolarToRect;
  datapolartorect->setName("DataPolarToRect");
  Map *exp = new Exp;
  exp->setName("Exp");
  Map *log = new Log;
  log->setName("Log");

  // Constants

  new Constant(3.14159265359,"PI");  
}
