/*  traspose.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "traspose.h"
#include "../constant.h"
#include "../parameter.h"
#include "../tmatrix.h"
#include "../matrix.h"
#include <kdebug.h>

MatrixTraspose::MatrixTraspose (void) : 
			MapInternal("","m","")
{ }

MatrixTraspose::MatrixTraspose(const MatrixTraspose &m) : MapInternal(m)
{ }

Map *MatrixTraspose::copy(void) const
{ 
  return new MatrixTraspose(*this); 
}

Map *MatrixTraspose::eval(const QDict <Map> &vars)
{
   QDict <Map> *vars2=evalParams(vars);
   Map *m=vars2->find("m");
   Map *r;
   if (m->isA("Matrix"))
   {
     kdDebug() << "MatrixTraspose::eval" << endl;
     TMatrix *mat=m->tmatrix();
     mat->traspose();
     r=new Matrix(mat); //XXX Possible mem leakage
   }
   else
   {
     r=new MatrixTraspose;
     r->setParameterExpression(0,m->copy());
   }
   delete vars2;
   return r;
}

QString MatrixTraspose::string(void) const
{
  return QString("MatrixTraspose(%1)").arg(m_parameters[0]->string());
}


