/*  garbage.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "garbage.h"
#include "vartype.h"
#include "map.h"
#include <qlist.h>
#include <kdebug.h>
#include <unistd.h>

QList <T> Garbage::m_TGarbage[128];
QList <Map> Garbage::m_MapGarbage[128];

void Garbage::collect(void)
{
//  kdDebug() << "Garbage::collect" << endl;
//  kdDebug() << "Elements:" << m_TGarbage[m_current].count() << " " << m_MapGarbage[m_current].count() << endl;
  m_TGarbage[m_current].setAutoDelete(TRUE);
  m_TGarbage[m_current].clear();
  m_MapGarbage[m_current].setAutoDelete(TRUE);
  m_MapGarbage[m_current].clear();
}

void Garbage::throwT(const T *t)
{
  m_TGarbage[m_current].append(t);
//  kdDebug() << "Garbage:: " << m_TGarbage[m_current].count() << endl;
}

void Garbage::throwMap(const Map *m)
{
  m_MapGarbage[m_current].append(m);
//  kdDebug() << "Garbage:2: " << m_MapGarbage[m_current].count() << endl;
}

int Garbage::m_current=0;

int Garbage::setCurrent(int current)
{
  int r=m_current;
  m_current=current;
  return r;
}

void Garbage::push(void)
{
  m_current++;
}

void Garbage::pop(void)
{
  collect();
  m_current--;
}
