/*  ccolor.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "ccolor.h"
#include "../color.h"
#include "../parameter.h"
#include <kdebug.h>

CColor::CColor() : MapVariableArgumentsInternal(QString::null,"Color",false)
{ 
  // XXX
  m_parameters[0]=new Parameter("r_or_name");
  m_parameters[1]=new Parameter("g");
  m_parameters[2]=new Parameter("b");
}

CColor::CColor(const CColor &m) : MapVariableArgumentsInternal( m )
{
}
  
Map *CColor::copy(void) const
{
  return new CColor(*this);
}

Map *CColor::eval(const QDict <Map> &vars)
{
  QDict <Map> *vars2=evalParams(vars);

  Map *c;
  if (nArgs()==1) // We have a named color
  {
    c=new Color(argument(0)->string());
  }
  else if (nArgs()==3) // We have r,g,b
  {
    c=new Color(*vars2->find("$0")->t(),*vars2->find("$1")->t(),*vars2->find("$2")->t());
  }
  else
    c=copy();
    
  delete vars2;

  return c;
}


QString CColor::string(void) const
{
  return QString("Color");
}
