/*  clear.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "clear.h"
#include "../constant.h"
#include <kdebug.h>

Clear::Clear() : MapVariableArgumentsInternal(QString::null,"Clear",false)
{
}

Clear::Clear(const Clear &m) : MapVariableArgumentsInternal( m )
{
}
  
Map *Clear::copy(void) const
{
  return new Clear(*this);
}

Map *Clear::eval(const QDict <Map> &)
{
//  kdDebug() << "Clear::eval" << endl;
  for (unsigned int i=0;i<nArgs();i++)
  {
//    kdDebug() << QString("%1) (%2)").arg(i).arg(argument(i)->string()) << endl;
    if (!maps.find(argument(i)->string())->isInternal())
      maps.remove(argument(i)->string());
  }

  return copy();
}

QString Clear::string(void) const
{
  return QString("Clear");
}
  
