/*  dim.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "dim.h"
#include "../constant.h"
#include "../matrix.h"
#include "../parameter.h"
//#include "../qtai/qtai_plot.h"
#include "../qtai/qtai_anim.h"
#include "graphs.h"
#include <kdebug.h>

Dim::Dim() : MapVariableArgumentsInternal(QString::null,"Dim",false)
{ 
}

Dim::Dim(const Dim &m) : MapVariableArgumentsInternal( m )
{
}
  
Map *Dim::copy(void) const
{
  return new Dim(*this);
}

Map *Dim::eval(const QDict <Map> &vars)
{
  QDict <Map> *vars2=evalParams(vars);
    
  Map *m=vars2->find("$0");
  TMatrix *mat=new TMatrix(1,2);
  if (m->isA("Matrix"))
  {
    TMatrix *mmat=m->tmatrix();
    mat->set(0,0,new Constant(mmat->nRows()));
    mat->set(0,1,new Constant(mmat->nCols()));
  }
  else
  {
    mat->set(0,0,new Constant(0.0));
    mat->set(0,1,new Constant(0.0));
  }

  delete vars2;
  
  return new Matrix(mat);
}

QString Dim::string(void) const
{
  return QString("Dim");
}
