/*  graphs.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "graphs.h"
#include "../qtai/qtai_plot.h"
#include "../qtai/qtai_anim.h"
#include "../kgl/kgl3dwidget.h"
#include "../tmatrix.h"
#include <qlist.h>
#include <qguardedptr.h>

Graphs::Graphs (QObject *parent, char *name) : QObject(parent,name)
{
  m_self=this;
}

int Graphs::add (const AIPlot *w)
{
  AIPlot *w_=(AIPlot *)w;
  QGuardedPtr <AIPlot> *a=new QGuardedPtr <AIPlot> (w_);
  m_graphs2D.append(a);
  return m_graphs2D.at();
}

int Graphs::add (const AIAnim *w)
{
  AIAnim *w_=(AIAnim *)w;
  QGuardedPtr <AIAnim> *a=new QGuardedPtr <AIAnim> (w_);
  m_graphs2DAnim.append(a);
  return m_graphs2DAnim.at();
}

int Graphs::add (const KGL3DWidget *w)
{
  KGL3DWidget *w_=(KGL3DWidget *)w;
  QGuardedPtr <KGL3DWidget> *a=new QGuardedPtr <KGL3DWidget> (w_);
  m_graphs3D.append(a);
  return m_graphs3D.at();
}

int Graphs::add (const TMatrix *w)
{
//  TMatrix *w_=(TMatrix *)w;
//  QGuardedPtr <TMatrix> *a=new QGuardedPtr <TMatrix> (w_);
  m_diffEq.append(w);
  return m_diffEq.at();
}

AIPlot *Graphs::plot2D(int i)
{
  QGuardedPtr <AIPlot> *p=m_graphs2D.at(i);
  if (!p) return 0L;
  return *p;
}

AIAnim *Graphs::anim2D(int i)
{
  QGuardedPtr <AIAnim> *p=m_graphs2DAnim.at(i);
  if (!p) return 0L;
  return *p;
}

KGL3DWidget *Graphs::plot3D(int i)
{
  QGuardedPtr <KGL3DWidget> *p=m_graphs3D.at(i);
  if (!p) return 0L;
  return *p;
}

TMatrix *Graphs::diffEq(int i)
{
  return m_diffEq.at(i);
}

QList <QGuardedPtr <AIPlot> > Graphs::m_graphs2D;
QList <QGuardedPtr <AIAnim> > Graphs::m_graphs2DAnim;
QList <QGuardedPtr <KGL3DWidget> > Graphs::m_graphs3D;
QList <TMatrix> Graphs::m_diffEq;
Graphs *Graphs::m_self=0L;
