/*  graphs.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include <qobject.h>
#include <qlist.h>
#include <qguardedptr.h>

//class QList <class type>;
class AIPlot;
class AIAnim;
class KGL3DWidget;
class TMatrix;

class Graphs : public QObject
{
public:
  Graphs (QObject *parent, char *name);

  static int add (const AIPlot *);
  static int add (const AIAnim *);
  static int add (const KGL3DWidget *);
  static int add (const TMatrix *);
  static AIPlot *plot2D(int);
  static AIAnim *anim2D(int);
  static KGL3DWidget *plot3D(int);
  static TMatrix *diffEq(int);

//public slots:
//  void closeGraph(QWidget *w);
  
private:
  static QList <QGuardedPtr <AIPlot> > m_graphs2D;
  static QList <QGuardedPtr <AIAnim> > m_graphs2DAnim;
  static QList <QGuardedPtr <KGL3DWidget> > m_graphs3D;
  static QList <TMatrix> m_diffEq;
  static Graphs *m_self;
  
};
