/*  plotdirectionfield.h - 
    This file is part of Kalamaris
    Copyright (C) 2001  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "../mapinternal.h"

class PlotDirectionField3D : public MapVariableArgumentsInternal
{
protected:
  class KGLObject *createGLObject(double xmin,double ymin,double zmin,
      double xmax,double ymax,double zmax, int xpart, int ypart, int zpart,
      double *xderiv, double *yderiv, double *zderiv);
public:
  PlotDirectionField3D(void);
  PlotDirectionField3D(const PlotDirectionField3D &m);
  virtual ~PlotDirectionField3D();
  
  virtual Map *copy(void) const;
  
  Map *eval(const QDict <Map> &vars);

  virtual QString string(void) const;
  virtual QString help(void) const;

};
