/*  setplot3dcolor.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "setplot3dcolor.h"
#include "../constant.h"
#include "../parameter.h"
#include "../color.h"
#include "../kgl/kgl3dwidget.h"
#include "../kgl/kgldataanimate.h"
//#include "../qtai/qtai_anim.h"
#include "graphs.h"
#include <kdebug.h>

SetPlot3DColor::SetPlot3DColor() : MapVariableArgumentsInternal(QString::null,"SetPlot3DColor",false)
{ 
  m_parameters[0]=new Parameter("graph");
  m_parameters[0]->setDataType("Constant");
  m_parameters[1]=new Parameter("plot");
  m_parameters[1]->setDataType("Constant");
  m_parameters[2]=new Parameter("color");
  m_parameters[2]->setDataType("Color");
}

SetPlot3DColor::SetPlot3DColor(const SetPlot3DColor &m) : MapVariableArgumentsInternal( m )
{
}
  
Map *SetPlot3DColor::copy(void) const
{
  return new SetPlot3DColor(*this);
}

Map *SetPlot3DColor::eval(const QDict <Map> &vars)
{
  QDict <Map> *vars2=evalParams(vars);
  if (!checkParamTypes(*vars2)) return 0L;
  int id=*vars2->find("$0")->t();
  int trace=*vars2->find("$1")->t();
  Color *color=(Color *)vars2->find("$2");

  KGL3DWidget *w=Graphs::plot3D(id);
  if (!w) // that graph has been closed !
     return 0L; // XXX
  KGLDataAnimate *plot=reinterpret_cast<KGLDataAnimate *>(w->universe());
  			//XXX explicit cast could be wrong !!!

  plot->setPlotColor(trace,color->color());
  plot->updateGL();

  delete vars2;
  
  return copy();
}

QString SetPlot3DColor::string(void) const
{
  return QString("SetPlot3DColor");
}
