/*  interpreter.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include <qobject.h>
#include "interpreterIface.h"

class QString;
class QPixmap;

class Interpreter : public QObject, virtual public interpreterIface
{
   Q_OBJECT
     
private:

  int seq;
  bool evaluateFunctions;

  static Interpreter *self;

public:
  Interpreter();
  ~Interpreter();

  QStringList mapNames();
  
  static Interpreter *interpreter(void) { return self; };

public slots:
  /**
   * Process a command line . Returns an identifier.
   */
  int process( QString input);
  void setFlagEvaluateFunctions( bool b=false );
  void setStepControl( bool b=false );

signals:  
  /**
   * These signals are emitted when there's output for a
   * processed line. The id is the identifier returned
   * by @ref process when the corresponding command line
   * was entered.
   */ 
  void outputString(int id, const QString &output);
  
  void outputPixmap(int id, const QPixmap &output);

  void inputString(int id, const QString &input);

  void error(int id, const QString &input);
};
