/*  kalamaris.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include <kmainwindow.h>
#include <kurl.h>

class MainWindow : public KMainWindow
{
  Q_OBJECT

  public:

    MainWindow ( const char * name );

    void parseAvailableMaps();

  public slots:
    void fileOpen();
    void fileSave();
    void processCmdline(const QString &);
    void interpreterOutput(int id, const QString &output);
    void interpreterInput(int id, const QString &input);
    void showHelp(const QString &mapname);
    void hideHelp();
    void helpProcess(const QString &cmd);
    void setPrecision();
    void setDataType(const QString &t);
    void showExamples();
/*    void setTolerancy();
    void setMaxIterations();
*/

  protected:
    void openFile( const QString &filename );
    void saveFile( const QString &filename );

  private:

    class QTextView *lastcmd;
    class QVBox     *help;
    class MapBrowser *mapbrowser;
    class QSplitter *splitter;
    class KHistoryCombo *cmdline;
    class Interpreter *interpreter;

    QStringList history;
};
