/*  kgl3dwidget.h - 
    This file is part of KGL
    Copyright (C) 2000,2001  Antonio Larrosa Jimenez
    KGL' homepage : http://devel-home.kde.org/~larrosa/kgl.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include <qhbox.h>

class File3DView;
class QScrollBar;
class QSlider;
class QPushButton;
class KGLUniverse;
class KGLControls;

class KGL3DWidget : public QHBox
{
  Q_OBJECT

public:
    KGL3DWidget(QWidget *parent, const char *name=0L);
    virtual ~KGL3DWidget();

    KGLUniverse *universe() { return m_universe; };
    void setUniverse(KGLUniverse *universe);

    KGLControls *controls() { return m_controls; };
//    int heightForWidth(int w) { return w; };
    virtual QSize sizeHint() const { return QSize(300,300); };

signals:
    void closing (KGL3DWidget *);

protected:
    virtual void closeEvent(QCloseEvent *);

private:
    KGLUniverse * m_universe;
    KGLControls * m_controls;

};
