/*  kglcontrol.cpp - 
    This file is part of KGL
    Copyright (C) 2000,2001  Antonio Larrosa Jimenez
    KGL' homepage : http://devel-home.kde.org/~larrosa/kgl.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "kglcontrol.h" 
#include "kgluniverse.h"
#include <klocale.h>
#include <qscrollbar.h>
#include <qslider.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qtooltip.h>

KGLControls::KGLControls(QWidget *parent, const char *name)
	: KGLControlWidget( parent, name)
{
  m_universe=0L;
}

KGLControls::~KGLControls()
{
}

void KGLControls::plug(KGLUniverse *u)
{
  m_universe=u;

  connect(w_sliderX,SIGNAL(valueChanged(int)),m_universe,SLOT(moveX(int)));
  connect(w_sliderY,SIGNAL(valueChanged(int)),m_universe,SLOT(moveY(int)));
  connect(w_sliderZ,SIGNAL(valueChanged(int)),m_universe,SLOT(moveZ(int)));
  connect(w_sliderPhi,SIGNAL(valueChanged(int)),m_universe,SLOT(movePhi(int)));
  connect(w_sliderPsi,SIGNAL(valueChanged(int)),m_universe,SLOT(movePsi(int)));
  connect(w_sliderTwist,SIGNAL(valueChanged(int)),m_universe,SLOT(twist(int)));
  connect(w_sliderTwist,SIGNAL(sliderReleased()),m_universe,SLOT(resetTwist()));
  connect(w_sliderDistanceToCenter,SIGNAL(valueChanged(int)),
	m_universe, SLOT(setDistanceToCenter(int)));
  connect(w_sliderViewAngle,SIGNAL(valueChanged(int)),
	m_universe,SLOT(setViewAngle(int)));
  connect(w_sliderSpeed,SIGNAL(valueChanged(int)),
	m_universe,SLOT(setSpeed(int)));

  connect(w_moveForward,SIGNAL(clicked()),m_universe,SLOT(moveForward()));
  connect(w_moveBackward,SIGNAL(clicked()),m_universe,SLOT(moveBackward()));
  connect(w_lookToOrigin,SIGNAL(clicked()),m_universe,SLOT(lookToOrigin()));

  connect(m_universe, SIGNAL(movedX(int)), w_sliderX,SLOT(setValue(int)));
  connect(m_universe, SIGNAL(movedY(int)), w_sliderY,SLOT(setValue(int)));
  connect(m_universe, SIGNAL(movedZ(int)), w_sliderZ,SLOT(setValue(int)));
  connect(m_universe, SIGNAL(phiChanged(int)), w_sliderPhi,SLOT(setValue(int)));
  connect(m_universe, SIGNAL(psiChanged(int)), w_sliderPsi,SLOT(setValue(int)));
  connect(m_universe, SIGNAL(twistChanged(int)),
	w_sliderTwist,SLOT(setValue(int)));
  connect(m_universe, SIGNAL(distanceToCenterChanged(int)),
	w_sliderDistanceToCenter,SLOT(setValue(int)));

  if (w_sliderViewAngle) w_sliderViewAngle->setValue(40000);
}
