/*  kgldataanimate.h - 
    This file is part of KGL
    Copyright (C) 2000,2001  Antonio Larrosa Jimenez
    KGL' homepage : http://devel-home.kde.org/~larrosa/kgl.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "kgluniverse.h"

class KGLObject;
#define MAX_KGLTRACES 16

class KGLDataAnimate : public KGLUniverse
{
  Q_OBJECT

public:
  KGLDataAnimate(QWidget *parent,const char *name="kgldataanimate");
  virtual ~KGLDataAnimate();

  /*
   * Sets a new set of data with x,y,z points (count is the number of points)
   * returns the identifier for this "trace"
   */
  int animateData(double *x,double *y,double *z,int count);
  int plotData(double *x,double *y,double *z,int count);
  void setPlotColor(int idx, const QColor &color);

public slots:
  void        timerTriggered(); 

protected:

  int m_ntraces;


// XXX These should be in a struct
  double * m_dataX[MAX_KGLTRACES];
  double * m_dataY[MAX_KGLTRACES];
  double * m_dataZ[MAX_KGLTRACES];
  KGLObject *m_trace[MAX_KGLTRACES];
  int  m_count[MAX_KGLTRACES];
  int  m_animCount[MAX_KGLTRACES];
  
  QColor m_color[MAX_KGLTRACES];
  bool m_animate[MAX_KGLTRACES];

  QTimer *m_timer;
};
