/*  kglline.cpp - 
    This file is part of KGL
    Copyright (C) 2001  Antonio Larrosa Jimenez
    KGL' homepage : http://devel-home.kde.org/~larrosa/kgl.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "kglline.h"
#include "kglelements.h"

KGLLine::KGLLine(GLfloat x1, GLfloat y1, GLfloat z1,
    GLfloat x2, GLfloat y2, GLfloat z2) : KGLObject(0,0,0)
{
  m_list = glGenLists(1);
  glNewList(m_list, GL_COMPILE);

  glBegin(GL_LINE_STRIP); 
  glMaterialfv( GL_FRONT, GL_EMISSION, color() );
//  glColor4fv( color() );
  glVertex3f(x1,y1,z1);
  glVertex3f(x2,y2,z2);
  glMaterialfv( GL_FRONT, GL_EMISSION, KGLObject::c_black );

  glEnd(); 
  glEndList(); 
  
}

KGLLine::KGLLine(GLfloat *x, GLfloat *y, GLfloat *z, int n, bool segments) : KGLObject(0,0,0)
{
  m_list = glGenLists(1);
  glNewList(m_list, GL_COMPILE);

  if (segments) glBegin(GL_LINES);
  else glBegin(GL_LINE_STRIP); 
//  glMaterialfv( GL_FRONT, GL_EMISSION, color() );
//  glColor4fv( color() );
  for (int i=0; i<n; i++)
    glVertex3f(*(x++),*(y++),*(z++));
//  glMaterialfv( GL_FRONT, GL_EMISSION, KGLObject::c_black );

  glEnd(); 
  glEndList(); 
  
}

KGLLine::KGLLine(double *x, double *y, double *z, int n,bool segments) : KGLObject(0,0,0)
{
  m_list = glGenLists(1);
  glNewList(m_list, GL_COMPILE);

  if (segments) glBegin(GL_LINES);
  else glBegin(GL_LINE_STRIP); 
  for (int i=0; i<n; i++)
    glVertex3f((GLfloat)*(x++),(GLfloat)*(y++),(GLfloat)*(z++));
//  glMaterialfv( GL_FRONT, GL_EMISSION, KGLObject::c_black );

  glEnd(); 
  glEndList(); 
  
}

