/*  kglsphere.cpp - 
    This file is part of KGL
    Copyright (C) 2000,2001  Antonio Larrosa Jimenez
    KGL' homepage : http://devel-home.kde.org/~larrosa/kgl.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "kglsphere.h"
#include <qgl.h>

KGLSphere::KGLSphere(GLfloat x, GLfloat y, GLfloat z,
    GLfloat r, int slices, const QImage &texture) : KGLObject(x,y,z)
{
  m_list = glGenLists(1);
  glNewList(m_list, GL_COMPILE);
  GLUquadricObj* q = gluNewQuadric();
  gluQuadricDrawStyle( q, (GLenum) GLU_FILL );
  gluQuadricNormals( q, (GLenum) GLU_SMOOTH );
  gluQuadricTexture(q, GL_TRUE);

  if (!texture.isNull())
  {
    m_texture = texture.convertDepth( 32 ).mirror().swapRGB();
    glEnable( GL_TEXTURE_2D );
    glTexImage2D( GL_TEXTURE_2D, 0, 3, m_texture.width(), m_texture.height(),
	0, GL_RGBA, GL_UNSIGNED_BYTE, m_texture.bits() );
  }

  gluSphere(q, r, slices, slices);

  glEndList();

  gluDeleteQuadric(q);

  if (!texture.isNull())
    glDisable( GL_TEXTURE_2D );

}

