/*  main.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include <kapp.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include "kalamaris.h"

int main( int argc, char **argv )
{
  KAboutData *aboutdata = new KAboutData("kalamaris", "Kalamaris", "0.7.2",
      "Mathematica like interpreter", KAboutData::License_GPL,
      "(C) 2000-2002 Antonio Larrosa Jimenez","",
      "http://devel-home.kde.org/~larrosa/kalamaris.html");
  aboutdata->addAuthor("Antonio Larrosa Jimnez",
      I18N_NOOP("Main Developer/Mantainer"),"larrosa@kde.org",
      "http://devel-home.kde.org/~larrosa/kalamaris.html");

  KCmdLineArgs::init(argc, argv, aboutdata);

  static KCmdLineOptions options[] =
  {
    { "+file", I18N_NOOP("File to open"), 0 },
    { 0, 0, 0}
  };
  KCmdLineArgs::addCmdLineOptions(options);


  KApplication a;

  MainWindow *window=new MainWindow( "Kalamaris" );
  window->resize( 500, 400 );

  a.setMainWidget( window );
  window->show();

  return a.exec();
}

