/*  mapbrowser.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include <khtml_part.h>
#include <kurl.h>

class MapBrowser : public QObject
{
  Q_OBJECT

    KHTMLPart *html;
  
  class QString m_fname;

public:
  MapBrowser(QWidget *parent);

public slots:
  void helpOpenURL(const KURL &url);
  void requestPlotFunction();
  void demoPendulum();
  void demoExponential();
  void showDemoIndex();

signals:
  void process(const QString &cmd);
  
public:
  void plotFunction(const QString &name, const QString &query);
  QString getKey(const QStringList &parameters, const QString &key) const;
  QString getNumKey(const QStringList &parameters, const QString &key) const;

protected:
  void resizeEvent(const QResizeEvent &);

  KURL url;
};
