/*  mapinternal.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#ifndef _MAPINTERNAL_H
#define _MAPINTERNAL_H

#include "map.h"
#include "mapvararg.h"

class MapInternal : public Map
{
public:
  MapInternal (const QString &decl=QString(),
              const QStringList &params=QStringList(),
	              const QString &nam=QString(), bool parsedefinition=true)
     : Map (decl,params,nam,parsedefinition) 
     { };
  MapInternal (const MapInternal &m) : Map(m) 
  { };
  
  /**
   * Returns a simplified form of this Map if possible.
   * If there's no simplified form, it returns 0L .
   */
  virtual Map *simplify();

  virtual inline bool isInternal(void) const { return true; };

  virtual QString help(void) const { return "Internal Map class without help"; };
};

class MapVariableArgumentsInternal : public MapVariableArguments
{
public:
 MapVariableArgumentsInternal ( const QString &decl = QString(), const QString &nam = QString(),
     				bool parsedefinition=true )
   : MapVariableArguments( decl, nam, parsedefinition )
   { }
  MapVariableArgumentsInternal (const MapVariableArgumentsInternal &m) 
    : MapVariableArguments(m)
    { }
  
  /**
   * Returns a simplified form of this Map if possible.
   * If there's no simplified form, it returns 0L .
   */
  virtual Map *simplify();

  virtual inline bool isInternal(void) const { return true; };

  virtual QString help(void) const { return "Internal MapVariableArguments class without help"; };
};

#endif
