/*  fehlberg.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "mapmethod.h"

//class TMatrix;
//class T;

class MethodFehlberg : public MapMethod
{
protected:
  void calcH0(const TMatrix &f,const TMatrix &x, const TMatrix &y,
      QDict <Map> &vars, unsigned int k, unsigned int n,const T &h, TMatrix &H,
      const T &x2,const T &x3,const T &x4,const T &x5,const T &x6,
      TMatrix &fx1, TMatrix &fx2, TMatrix &fx3, TMatrix &fx4, TMatrix &fx5);
  void calcH1(const TMatrix &f,const TMatrix &x, const TMatrix &y,
      QDict <Map> &vars, unsigned int k, unsigned int n,const T &h, TMatrix &H,
      const T &x2,const T &x3,const T &x4,const T &x5,const T &x6,
      TMatrix &fx1, TMatrix &fx2, TMatrix &fx3, TMatrix &fx4, TMatrix &fx5);
  void calcH2(const TMatrix &f,const TMatrix &x, const TMatrix &y,
      QDict <Map> &vars, unsigned int k, unsigned int n,const T &h, TMatrix &H,
      const T &x2,const T &x3,const T &x4,const T &x5,const T &x6,
      TMatrix &fx1, TMatrix &fx2, TMatrix &fx3, TMatrix &fx4, TMatrix &fx5);
  void calcH3(const TMatrix &f,const TMatrix &x, const TMatrix &y,
      QDict <Map> &vars, unsigned int k, unsigned int n,const T &h, TMatrix &H,
      const T &x2,const T &x3,const T &x4,const T &x5,const T &x6,
      TMatrix &fx1, TMatrix &fx2, TMatrix &fx3, TMatrix &fx4, TMatrix &fx5);
  void calcH4(const TMatrix &f,const TMatrix &x, const TMatrix &y,
      QDict <Map> &vars, unsigned int k, unsigned int n,const T &h, TMatrix &H,
      const T &x2,const T &x3,const T &x4,const T &x5,const T &x6,
      TMatrix &fx1, TMatrix &fx2, TMatrix &fx3, TMatrix &fx4, TMatrix &fx5);
public:
  MethodFehlberg(void);
  MethodFehlberg(const MethodFehlberg &m);
  virtual ~MethodFehlberg();
  
  virtual Map *copy(void) const;
  
  Map *eval(const QDict <Map> &vars);

  virtual QString string(void) const;
  virtual QString help(void) const;

};
