/*  init.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "euler.h"
#include "midpoint.h"
#include "fehlberg.h"
#include "rk38.h"
#include "adams.h"
#include "fehlberg78.h"
#include "../constant.h"

void init_methods(void)
{
//  new MethodEuler;
  new MethodMiddlePoint;
  new MethodFehlberg;
  new MethodRungeKutta38;
  new MethodAdams(1);
  new MethodAdams(2);
  new MethodFehlberg78;

  // Constants 

  new Constant(0.0001,"_tolerance");
  new Constant(10,"_maxIterations");
  new Constant(1.5,"_stepControlFactor");
  new Constant(1,"_stepControl");
}
