/*  operator.h - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "map.h"

class Operator : public Map
{
protected:

  /**
   * Operator : '+' , '-' , '*' , '/' , '^'
   */
  char m_op;

  Map *m_tree1;
  Map *m_tree2;

public:
  Operator(char op, const QString &t1, const QString &t2);
  Operator(char op, Map *m1, Map *m2);
  virtual ~Operator();

  virtual Map *copy(void) const; 

  virtual Map *eval (const QDict <Map> &vars);
  virtual Map *derive(const Variable &, const QDict <Map> &vars);

  virtual QString string(void) const;

  virtual void propagateForceEvaluation( bool b=true );
  virtual Map *simplify(void);
    
};
