/*  qtai_anim.cpp -
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://devel-home.kde.org/~larrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "qtai_anim.h"
#include <qtimer.h>
#include <kdebug.h>

AIAnim::AIAnim(QWidget *parent,const char *name,int b,int t) 
  : AIPlot(parent, name, b, t)  
{
  m_delay=200;
//  for (int i=0;i<8;i++) m_animPoint[i]=0;
  setWFlags(WRepaintNoErase|getWFlags());
  m_timer=new QTimer(this);
  connect(m_timer,SIGNAL(timeout()), this, SLOT(timerTriggered()));
  m_timer->start(m_delay);
}

AIAnim::~AIAnim()
{
  m_timer->stop();
  delete m_timer;
}

void AIAnim::setDelay(int d)
{
  if (d>0) m_delay=d;
}

void AIAnim::timerTriggered()
{
  Trace *t;
  for ( t=traces.first(); t != 0; t=traces.next() )
  {
    t->animPoint++;
    if (t->animPoint==t->qn) t->animPoint=0;
  }
  repaint(0,0,width(),height(),FALSE); //XXX I suppose it can be optimized
                                       // to not draw the whole widget
};
/*
void AIAnim::drawAnim( QPainter *p )
{

  int fact=10;
  QColor   c;

  int      w;
  int      h;

  int fh;
  int fw;
  double   w100=(double)w/100.0f;
  double   h100=(double)h/100.0f;
             

  w=width()*fact;
  h=height()*fact;

  static double ozoomx1=0,ozoomy1=0,ozoomx2=0,ozoomy2=0;
  static double lzx1,lzy1,lzx2,lzy2;

  lzx1=zoomx1[zoomed_in],lzy1=zoomy1[zoomed_in];
  lzx2=zoomx2[zoomed_in],lzy2=zoomy2[zoomed_in];

  p->setViewport(0,0,width(),height());
  p->setWindow(0,0,width(),height());
  
  p->setViewport(50,30,width()-80,height()-80);
  p->setClipRect(50,30,width()-80,height()-80);

  if (zoomed_in>0) {
    p->setWindow((int)(zoomx1[zoomed_in]*w100),
	(int)(zoomy1[zoomed_in]*h100),
	(int)((zoomx2[zoomed_in]-zoomx1[zoomed_in])*(double)w100),
	(int)((zoomy2[zoomed_in]-zoomy1[zoomed_in])*(double)h100));
  } else {
    p->setWindow(0,0,w,h);   // defines coordinate system
  } 

  
  QRect r;
  r.setWidth(100);
  r.setHeight(100);
  QRect r2;
  r2.setWidth(2);
  r2.setHeight(2);
  for (int i=0;i<traces;i++)
  {
    p->setPen( Qt::white );
    QPoint pt=qa[i]->point(m_animPoint[i]);
    r.moveCenter(pt);
    r2.moveCenter(pt);
//    kdDebug() << r.left() << " " << r.top() << " - " << r.width() << " " << r.height() << endl;
    p->drawEllipse(r);
    p->drawEllipse(r2);
//    p->fillRect(r,QColor( Qt::white ));
  }
}
*/
void AIAnim::drawFurtherGraph( QPainter *p )
{
   QRect r;
  r.setWidth(100);
  r.setHeight(100);
/*  QRect r2;
  r2.setWidth(2);
  r2.setHeight(2);
  */
  QBrush oldBrush=p->brush();
  QPen oldPen=p->pen();
  Trace *t;
  for ( t=traces.first(); t != 0; t=traces.next() )
  {
    p->setPen( t->color );
    p->setBrush( t->color );
    QPoint pt=t->qa->point(t->animPoint);
    r.moveCenter(pt);
//    r2.moveCenter(pt);
//    kdDebug() << r.left() << " " << r.top() << " - " << r.width() << " " << r.height() << endl;
    p->drawEllipse(r);
//    p->drawEllipse(r2);
//    p->fillRect(r,QColor( Qt::white ));
  }
  p->setPen( oldPen );
  p->setBrush( oldBrush );
 
}

